const { services } = require('pubsweet-component-helper-service')

module.exports = models => async (req, res) => {
  // TO DO: add authsome
  const { collectionId, fragmentId } = req.params
  try {
    const collection = await models.Collection.find(collectionId)
    if (!collection.fragments.includes(fragmentId))
      return res.status(400).json({
        error: `Fragment ${fragmentId} does not match collection ${collectionId}`,
      })

    const { authors = [] } = await models.Fragment.find(fragmentId)
    const activeUsers = (await Promise.all(
      authors.map(author => models.User.find(author.id)),
    ))
      .filter(u => u.isActive)
      .map(u => u.id)

    const activeAuthors = authors.filter(author =>
      activeUsers.includes(author.id),
    )

    return res.status(200).json(activeAuthors)
  } catch (e) {
    const notFoundError = await services.handleNotFoundError(e, 'item')
    return res.status(notFoundError.status).json({
      error: notFoundError.message,
    })
  }
}
